:- module(conflictSolve_parb_super, [conflictResolution_supervisor/4]).


% conflictResolution_supervisor/4  to be invoked by the supervisor
%  see below for the details...
% conflictResolution_client  to be invoked by each client/agent (defined elsewhere)

:- use_module('settings.pl').


%conflictResolution_supervisor(+List, +StepNumber, -Goods, -Bads)
%determines the subset Goods of List consisting of the agents allowed to act
%those in Bads will be inhibited. (Goods=[] is allowed).
%
% PURE ARBITRATION APPROACH: relies on the arbitration strategy 
% specified by arbitrationStrategy/2 (see settings.pl)

% load the arbitration strategy  (see settings.pl)
:- arbitrationStrategy(_N, SupervisorModuleFile), use_module(SupervisorModuleFile).


conflictResolution_supervisor(PTACsList, _StepNum, Goods, Bads) :-
	findall(T-Act-'RETRY-OP', member(_-T-(Act-_Cs), PTACsList), TckAOptList),
	solveByArbitration(PTACsList, TckAOptList, Goods, Bads).


