% Options for multi agent coordination
:- module(settings, [theorySourceFile/4,temporaryFileName/1,conflictResolutionStrategy/3,arbitrationStrategy/2,numberOfAgents/1,maxNumberOfSteps/1]).

% number of autonomous agents
numberOfAgents(2).



% max length of the plan (each agent will performa at most these actions)
maxNumberOfSteps(9).


% For each agent: 
%    Index, Name, ActionDescriptionFile, and PlannerModuleFile:
% (Name could be a name for a group of agents that develop a plan in a
% centralized manner. In this case Name is a name for the group of agents) 
% Name is also used to specify which planners/agents an agent might help
% (by the laws "help Agents [if Cond]" )

theorySourceFile(1,black,'VolleyBlack.pl','bmap.pl').
theorySourceFile(2,white,'VolleyWhite.pl','bmap.pl').
%theorySourceFile(1,black,'SoccerBlack.pl','bmap.pl').
%theorySourceFile(2,white,'SoccerWhite.pl','bmap.pl').


%%%%%%theorySourceFile(3,referee,'VolleyR.pl','bmap.pl').
%%%%%%theorySourceFile(4,head,'VolleyH.pl','bmap.pl').
%theorySourceFile(3,che,'che.pl','sicsplan.pl').
%theorySourceFile(4,dan,'dan.pl','sicsplan.pl').
%theorySourceFile(5,eli,'eli.pl','sicsplan.pl').
%theorySourceFile(6,flo,'flo.pl','sicsplan.pl').
%theorySourceFile(7,gal,'gal.pl','sicsplan.pl').
%theorySourceFile(8,hon,'hon.pl','sicsplan.pl').


% temporary text file for storing Linda server address
temporaryFileName('tmpdata.txt').


% Strategy for conflict resolution
% (ENABLE ONE)
% -----------------------
% A fact of the form:
% conflictResolutionStrategy(name, module-file-for-supervisor, module-file-for-client).
% provided that the two files exist and define suitable modules/predicates...

% simply select one among the conflicting agents (the first one in the list)
%%%%%%%%%X%%
 conflictResolutionStrategy(choose_one, 'conflictSolve_sel_super.pl', 'conflictSolve_sel_client.pl').


% notify the conflicting agents and wait for their agreement on who can execute and who cannot
% conflictResolutionStrategy(roundrobin, 'conflictSolve_comm_super.pl', 'conflictSolve_comm_client.pl').

% directly apply arbitration as specified by the fact arbitrationStrategy/2 below
% (it does not interact with agents, neither it involves coordination. Just invoke arbitration.)
% conflictResolutionStrategy(pure_arbitration, 'conflictSolve_parb_super.pl', 'conflictSolve_parb_client.pl').

% 
% Strategy for arbitration (used by some of the above conflict-resolution options)
% (ENABLE ONE)
% -----------------------
% A fact of the form:
% arbitrationStrategy(name, module-file-for-supervisor).
% provided that the two file exists and defines suitable module/predicates...

% simply select one among the conflicting agents (the first one in the list)
 arbitrationStrategy(choose_one, 'arbitration_sel.pl').

% use a CSP to determine a maximal subset of non-conflicting agents
% arbitrationStrategy(optimalCSP, 'arbitration_opt.pl').



